/*
MsCOTT 0.01
By Gollum (c) 1999 Emu5ever
*/

// Includes
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cpu.h"
#include "utils.h"

// Defines
#define PROGRAM_NAME "MsCOTT"
#define PROGRAM_VERSION "0.01"

// General variables
char *Program_FileName;
unsigned long Program_FileSize;

// Emulation variables
unsigned char *PCMemory;

void ReadCommandLine(int Count,char *Str[])
{
 strcpy(Program_FileName,Str[1]);
 if (!strchr(Program_FileName,'.')) {
  strcat(Program_FileName,".com");
 }
}

void LoadProgramFile()
{
 FILE *Program_File;

 Program_File=fopen(Program_FileName,"rb");
 Program_FileSize=FileSize(Program_File);
 fread(PCMemory+0x100,1,Program_FileSize,Program_File);
 fclose(Program_File);
}

void DisplayHelp()
{
 printf("\n");
 printf("? or h(elp) : shows this help screen\n");
 printf("n(ext)      : step to next instruction\n");
 printf("t(race)     : trace current instruction\n");
 printf("d(ump)      : dump memory from current instruction\n");
 printf("r(un)       : execute from current instruction\n");
 printf("p(arams)    : parameters given to the program\n");
 printf("q(uit)      : exit MsCott\n");
 printf("\n");
}

void main(int ParamCount, char *ParamStr[])
{
 char command[256];
 char params[256];
 int Fin=0;

 PCMemory = new unsigned char[1024*1024]; // 1 Mo Memory
 Program_FileName = new char[256];
 ReadCommandLine(ParamCount,ParamStr);
 LoadProgramFile();
 CPUInitParity();
 ResetCPU(Program_FileSize);

 command[0]='\0';

 while (!Fin) {
  DebugCPU();
  printf("->");
  gets(command);

  if ((!strcmp(command,"q")) || (!strcmp(command,"quit")))
   Fin=1;
  else if ((!strcmp(command,"?")) || (!strcmp(command,"h")) || (!strcmp(command,"help")))
   DisplayHelp();
  else if ((!strcmp(command,"n")) || (!strcmp(command,"next")))
   NextIP();
  else if ((!strcmp(command,"t")) || (!strcmp(command,"trace")))
   EmuleCPU();
  else if ((!strcmp(command,"p")) || (!strcmp(command,"params"))) {
   scanf("%s",params);
   Lire_Params(params);
  } else if ((!strcmp(command,"r")) || (!strcmp(command,"run"))) {
   for(;;)
    EmuleCPU();
  } else if ((!strcmp(command,"d")) || (!strcmp(command,"dump")))
   DumpMEM();
 }
 delete Program_FileName;
 delete PCMemory;
}
