#ifndef _REGISTERS
#define _REGISTERS

typedef union {
  struct {
   word X;
   word Left;
  } Word;      // One word...
  dword EX; // ...or a double word
} EIP_Register;

// General CPU Types
typedef struct {
 union {
  struct {
   union {
    struct {
     byte L;
     byte H;
    } Byte; // One byte...
    word X; // ...or one word
   };
   word Left;
  } Word;   // One word...
  dword EX; // ...or one double word
 };
} CPU_Register;

// General CPU Registers
CPU_Register Registers[8];
word SegRegisters[6];
dword eflags;
EIP_Register eip;

// Easy access to 8-bit registers
#define AH Registers[0].Word.Byte.H
#define AL Registers[0].Word.Byte.L
#define CH Registers[1].Word.Byte.H
#define CL Registers[1].Word.Byte.L
#define DH Registers[2].Word.Byte.H
#define DL Registers[2].Word.Byte.L
#define BH Registers[3].Word.Byte.H
#define BL Registers[3].Word.Byte.L

// Easy access to 16-bit registers
#define AX Registers[0].Word.X
#define CX Registers[1].Word.X
#define DX Registers[2].Word.X
#define BX Registers[3].Word.X
#define SP Registers[4].Word.X
#define BP Registers[5].Word.X
#define SI Registers[6].Word.X
#define DI Registers[7].Word.X

#define IP eip.Word.X

// Easy access to 32-bit registers
#define EAX Registers[0].EX
#define ECX Registers[1].EX
#define EDX Registers[2].EX
#define EBX Registers[3].EX
#define ESP Registers[4].EX
#define EBP Registers[5].EX
#define ESI Registers[6].EX
#define EDI Registers[7].EX

#define EIP eip.EX
#define EFLAGS eflags

// Easy access to 16-bit segment registers
#define CS SegRegisters[0]
#define SS SegRegisters[1]
#define DS SegRegisters[2]
#define ES SegRegisters[3]
#define FS SegRegisters[4]
#define GS SegRegisters[5]

#endif
